﻿using Grayscale.P006_Syugoron;
using Grayscale.P025_KifuLarabe.L00012_Atom;
using Grayscale.P025_KifuLarabe.L00025_Struct;
using Grayscale.P025_KifuLarabe.L00050_StructShogi;
using Grayscale.P025_KifuLarabe.L002_GraphicLog;
using Grayscale.P025_KifuLarabe.L004_StructShogi;
using Grayscale.P025_KifuLarabe.L007_Random;
using Grayscale.P025_KifuLarabe.L012_Common;
using Grayscale.P025_KifuLarabe.L100_KifuIO;
using Grayscale.P027_SasiteSeisei.L050_MovableMove;
using System.Collections.Generic;
using Finger = ProjectDark.NamedInt.StrictNamedInt0; //スプライト番号
using System;
using System.Diagnostics;
using Grayscale.P027_SasiteSeisei.CS0_Interface.L00030_Sasiteseisei;
using Grayscale.P027_SasiteSeisei.L00030_Sasiteseisei;
using Grayscale.P027_SasiteSeisei.L080_Sasiteseisei;


namespace Grayscale.P027_SasiteSeisei.L100_Sasiteseisei_FukasaYusen
{

    /// <summary>
    /// 指し手生成ルーチン
    /// </summary>
    public class Sasiteseisei_FukasaYusen_Routine : Sasiteseisei_Routine
    {

        public Sasiteseisei_Genjo CreateGenjo(
            KifuTree kifu,
            bool isHonshogi,
            KwErrorHandler log
            )
        {
            KifuNode node_yomiNext = (KifuNode)kifu.CurNode;// このノードに、ツリーをぶら下げていきます。
            int yomuIndex = 0;



            // TODO:ここではログを出力せずに、ツリーの先端で出力したい。
            GraphicalLog_File logF_moveKiki = new GraphicalLog_File();

            // TODO:「読む」と、ツリー構造が作成されます。
            //int[] yomuLimitter = new int[]{
            //    600, // 読みの1手目の横幅   // 王手回避漏れのために、合法手全読み(約600)は必要です。
            //    100, // 読みの2手目の横幅
            //    100, // 読みの3手目の横幅
            //    //2, // 読みの4手目の横幅
            //    //1 // 読みの5手目の横幅
            //};

            //// ↓これなら１手１秒で指せる☆
            //int[] yomuLimitter = new int[]{
            //    600, // 読みの1手目の横幅   // 王手回避漏れのために、合法手全読み(約600)は必要です。
            //    150, // 読みの2手目の横幅
            //    150, // 読みの3手目の横幅
            //    //2 // 読みの4手目の横幅
            //    //1 // 読みの5手目の横幅
            //};

            //int[] yomuLimitter = new int[]{
            //    600, // 読みの1手目の横幅   // 王手回避漏れのために、合法手全読み(約600)は必要です。
            //    600, // 読みの2手目の横幅
            //    600, // 読みの3手目の横幅
            //};

            //ok
            //int[] yomuLimitter = new int[]{
            //    0,   // 現局面は無視します。
            //    600, // 読みの1手目の横幅   // 王手回避漏れのために、合法手全読み(約600)は必要です。
            //    600, // 読みの2手目の横幅
            //};

            int[] yomuLimitter = new int[]{
                0,   // 現局面は無視します。
                600, // 読みの1手目の横幅   // 王手回避漏れのために、１手目は、合法手全読み(約600)は必要です。
                600, // 読みの2手目の横幅
                //600, // 読みの3手目の横幅
            };

#if DEBUG
            // ログの出力数を減らすために、読みを弱くします。

            //yomuLimitter = new int[]{
            //    0,  // 現局面は無視します。
            //    600, // 読みの1手目の横幅   // 王手回避漏れのために、合法手全読み(約600)は必要です。
            //    100, // 読みの2手目の横幅
            //    100 // 読みの3手目の横幅
            //};

            yomuLimitter = new int[]{
                0,  // 現局面は無視します。
                600, // 読みの1手目の横幅   // 王手回避漏れのために、１手目は、合法手全読み(約600)は必要です。
                600, // 読みの2手目の横幅
                //600 // 読みの3手目の横幅
            };

            //yomuLimitter = new int[]{
            //    600, // 読みの1手目の横幅   // 王手回避漏れのために、合法手全読み(約600)は必要です。
            //    600, // 読みの2手目の横幅
            //    600, // 読みの3手目の横幅
            //    100,
            //    100
            //};

#endif
            Sasiteseisei_Args args = new Sasiteseisei_ArgsImpl(isHonshogi, yomuLimitter, logF_moveKiki);
            Sasiteseisei_Genjo genjo = new Sasiteseisei_GenjoImpl(args, yomuIndex + 1, kifu.CurrentTesumi(), kifu.CountPside(node_yomiNext));

            return genjo;
        }

        /// <summary>
        /// 読む。
        /// 
        /// 棋譜ツリーを作成します。
        /// </summary>
        /// <param name="kifu">この棋譜ツリーの現局面に、次局面をぶら下げて行きます。</param>
        /// <param name="enableLog"></param>
        /// <param name="isHonshogi"></param>
        /// <param name="logTag"></param>
        /// <returns></returns>
        public void WAA_Yomu_Start(
            KifuTree kifu,
            bool isHonshogi,
            KwErrorHandler owata
            )
        {
            Sasiteseisei_Genjo genjo = this.CreateGenjo(kifu, isHonshogi, owata);
            genjo.Node_yomiNext = (KifuNode)kifu.CurNode;// このノードに、ツリーをぶら下げていきます。


            try
            {
                Sasiteseisei_FukasaYusen_Routine.WAAA_Yomu_Loop(genjo, owata);
            }
            catch (Exception ex)
            {
                //>>>>> エラーが起こりました。
                string message = ex.GetType().Name + " " + ex.Message + "：棋譜ツリーの読みの中盤５０です。：";
                Debug.Fail(message);

                // どうにもできないので  ログだけ取って、上に投げます。
                owata.LogTag.WriteLine_Error(message);
                throw ex;
            }

            try
            {
                if (0 < genjo.Args.LogF_moveKiki.boards.Count)//ﾛｸﾞが残っているなら
                {
                    //
                    // ログの書き出し
                    //
                    Util_GraphicalLog.Log(
                        true,//enableLog,
                        "SasiteRoutine#Yomi_NextNodes(00)新ログ",
                        "[" + Util_GraphicalLog.BoardFileLog_ToJsonStr(genjo.Args.LogF_moveKiki) + "]"
                    );

                    // 書き出した分はクリアーします。
                    genjo.Args.LogF_moveKiki.boards.Clear();
                }
            }
            catch (Exception ex)
            {
                owata.DonimoNaranAkirameta(ex, "棋譜ツリーの読みの後半９０です。"); throw ex;
            }

        }



        /// <summary>
        /// 棋譜ツリーに、ノードを追加していきます。再帰します。
        /// </summary>
        /// <param name="node_yomiCur"></param>
        /// <param name="genjo"></param>
        /// <param name="isAiteban"></param>
        /// <param name="owata"></param>
        private static void WAAA_Yomu_Loop(
            Sasiteseisei_Genjo genjo,
            KwErrorHandler owata
            )
        {
            //
            // まず前提として、
            // 現手番の「被王手の局面」だけがピックアップされます。
            // これはつまり、次の局面がないときは、その枝は投了ということです。
            //

            KifuNode hub_NextNodes;
            try
            {
                // このハブ・ノード自身は空っぽで、ハブ・ノードの次ノードが、次局面のリストになっています。
                hub_NextNodes = Sasiteseisei_FukasaYusen_Routine.WAAAA_CreateNextNodes(
                    genjo,
                    owata);
            }
            catch (Exception ex)
            {
                owata.DonimoNaranAkirameta(ex, "棋譜ツリーの読みループの前半１０です。");  throw ex;
            }

            try
            {
                //
                // （２）現在の局面に、読んだ局面を継ぎ足します。
                //
                genjo.Node_yomiNext.AppdendNextNodes(//現在ノード
                    hub_NextNodes);
            }
            catch (Exception ex)
            {
                owata.DonimoNaranAkirameta(ex, "棋譜ツリーの読みループの前半２０です。"); throw ex;
            }


            try
            {
                Sasiteseisei_FukasaYusen_Routine.WAAAA_Create_NextBranch(genjo, hub_NextNodes, owata);
            }
            catch (Exception ex)
            {
                owata.DonimoNaranAkirameta(ex, "棋譜ツリーの読みループの後半７０です。"); throw ex;
            }


            try
            {
                if (genjo.Node_yomiNext.IsLeaf)//現在ノード
                {
                }
                else
                {
                    // TODO: 葉ノードではない（次のノードがある）なら、次枝読みが終わったので、この中間ノードの局面データは使われませんので破棄します。
                    //node_yomiCur.Lock_Kyokumendata();
                }

            }
            catch (Exception ex)
            {
                owata.DonimoNaranAkirameta(ex, "棋譜ツリーの読みループの後半９０です。"); throw ex;
            }

        }

        /// <summary>
        /// まず前提として、
        /// 現手番の「被王手の局面」だけがピックアップされます。
        /// これはつまり、次の局面がないときは、その枝は投了ということです。
        /// </summary>
        /// <param name="enableLog"></param>
        /// <param name="isHonshogi"></param>
        /// <param name="yomuDeep"></param>
        /// <param name="tesumi_yomiCur"></param>
        /// <param name="pside_yomiCur"></param>
        /// <param name="node_yomiCur"></param>
        /// <param name="logF_moveKiki"></param>
        /// <param name="logTag"></param>
        /// <returns>複数のノードを持つハブ・ノード</returns>
        private static KifuNode WAAAA_CreateNextNodes(
            Sasiteseisei_Genjo genjo,
            KwErrorHandler owata
            )
        {
            // 利きから、被王手の局面を除いたハブノード
            // このハブ・ノード自身は空っぽで、ハブ・ノードの次ノードが、次局面のリストになっています。
            KifuNode hubNode;
            {

                // ①現手番の駒の移動可能場所_被王手含む


                MmGenjo_MovableMasuImpl mm_genjo = null;
                try
                {
                    mm_genjo = new MmGenjo_MovableMasuImpl(
                            genjo.Args.IsHonshogi,//本将棋か
                            genjo.Node_yomiNext.Value.ToKyokumenConst,//現在の局面  // FIXME:Lockすると、ここでヌルになる☆
                            genjo.Pside_teban,//手番
                            false//相手番か
                            );
                }
                catch (Exception ex)
                {
                    owata.DonimoNaranAkirameta(ex, "棋譜ツリーの読みループの作成次ノードの前半１０です。"); throw ex;
                }

                MmLogGenjoImpl mm_log = null;
                GraphicalLog_Board logBrd_move1 = new GraphicalLog_Board();// 盤１個分のログの準備
                try
                {
                    mm_log = new MmLogGenjoImpl(
                            logBrd_move1,//ログ？
                            genjo.YomuDeep,//読みの深さ
                            genjo.Tesumi_yomiCur,//手済み
                            genjo.Node_yomiNext.Key,//指し手
                            owata//ログ
                        );
                }
                catch (Exception ex)
                {
                    owata.DonimoNaranAkirameta(ex, "棋譜ツリーの読みループの作成次ノードの前半２０です。"); throw ex;
                }

                List_OneAndMulti<Finger, SySet<SyElement>> komaBETUSusumeruMasus;
                try
                {
                    Util_MovableMove.LA_Get_KomaBETUSusumeruMasus(
                        out komaBETUSusumeruMasus,//進めるマス
                        mm_genjo,
                        mm_log
                    );
                }
                catch (Exception ex)
                {
                    owata.DonimoNaranAkirameta(ex, "棋譜ツリーの読みループの作成次ノードの前半３０です。"); throw ex;
                }

                try
                {
                    Sasiteseisei_FukasaYusen_Routine.Log1(genjo, logBrd_move1);//ログ試し
                }
                catch (Exception ex)
                {
                    owata.DonimoNaranAkirameta(ex, "棋譜ツリーの読みループの作成次ノードの前半４０です。"); throw ex;
                }


                // ②利きから、被王手の局面を除いたハブノード
                if (genjo.Args.IsHonshogi)
                {
                    try
                    {
                        Maps_OneAndMulti<Finger, ShootingStarlightable> komaBETUAllSasites = Converter04.KomaBETUSusumeruMasus_ToKomaBETUAllSasites(komaBETUSusumeruMasus, genjo.Node_yomiNext);
                        Converter04.AssertNariSasite(komaBETUAllSasites, "#WAAAA_CreateNextNodes(1)");

                        // 本将棋の場合、王手されている局面は削除します。
                        hubNode = Util_LegalMove.LA_RemoveMate(
                            genjo.Args.IsHonshogi,
                            komaBETUAllSasites,
                            genjo.YomuDeep,
                            genjo.Tesumi_yomiCur,
                            genjo.Pside_teban,
                            genjo.Node_yomiNext,
                            genjo.Args.LogF_moveKiki,//利き用
                            "読みNextルーチン",
                            owata);
                    }
                    catch (Exception ex)
                    {
                        owata.DonimoNaranAkirameta(ex, "棋譜ツリーの読みループの作成次ノードの中盤５０です。"); throw ex;
                    }


                    try
                    {
                        Converter04.AddNariSasite(genjo.Node_yomiNext, hubNode, owata);
                    }
                    catch (Exception ex)
                    {
                        owata.DonimoNaranAkirameta(ex, "王手局面除去後に成りの指し手を追加していた時です。"); throw ex;
                    }


                    Converter04.AssertNariSasite(hubNode, "#WAAAA_CreateNextNodes(2)");//ここで消えていた☆
                }
                else
                {
                    try
                    {
                        //そのまま変換
                        Dictionary<ShootingStarlightable, KyokumenWrapper> ss = Converter04.KomabetuMasus_ToSasitebetuSky(
                            komaBETUSusumeruMasus,
                            genjo.Node_yomiNext.Value.ToKyokumenConst,
                            genjo.Pside_teban,
                            owata);
                        hubNode = Converter04.SasitebetuSky_ToHubNode(ss, KifuNodeImpl.GetReverseTebanside(genjo.Pside_teban));
                    }
                    catch (Exception ex)
                    {
                        owata.DonimoNaranAkirameta(ex, "棋譜ツリーの読みループの作成次ノードの後半９０です。"); throw ex;
                    }

                }
            }

            return hubNode;
        }
        private static void Log1(
            Sasiteseisei_Genjo genjo,
            GraphicalLog_Board logBrd_move1
            )
        {
            logBrd_move1.sasiteOrNull = genjo.Node_yomiNext.Key;


            RO_Star_Koma srcKoma = Util_Koma.AsKoma(logBrd_move1.sasiteOrNull.LongTimeAgo);
            RO_Star_Koma dstKoma = Util_Koma.AsKoma(logBrd_move1.sasiteOrNull.Now);


            // ログ試し
            logBrd_move1.Arrow.Add(new Gkl_Arrow(Util_Masu.AsMasuNumber(srcKoma.Masu), Util_Masu.AsMasuNumber(dstKoma.Masu)));
            genjo.Args.LogF_moveKiki.boards.Add(logBrd_move1);
        }


        /// <summary>
        /// 次の枝を作成します。
        /// </summary>
        private static void WAAAA_Create_NextBranch(
            Sasiteseisei_Genjo genjo,
            Node<ShootingStarlightable, KyokumenWrapper> hubNode_genTeban,
            KwErrorHandler owata
            )
        {
            // （３）次のノードをシャッフルします。
            List<KifuNode> nextNodes_shuffled = Converter04.NextNodes_ToList(hubNode_genTeban);
            LarabeShuffle<KifuNode>.Shuffle_FisherYates(ref nextNodes_shuffled);

            // （４）次の局面
            int wideCount = 0;
            foreach (KifuNode nextNode in nextNodes_shuffled)
            {
                // （５）読みの深さ指定以降なら、横幅制限
                if (1 < genjo.YomuDeep)
                {
                    if (genjo.Args.YomuLimitter[genjo.YomuDeep] <= wideCount)
                    {
                        break;// もう次の手の横には読まない。
                    }
                }


                // 《８》カウンターを次局面へ（２手目の読み）

                // 《９》まだ深く読むなら
                if (genjo.YomuDeep + 1 < genjo.Args.YomuLimitter.Length)
                {
                    genjo.YomuDeep ++;
                    genjo.Tesumi_yomiCur++;
                    genjo.Pside_teban = genjo.Pside_teban == Playerside.P1 ? Playerside.P2 : Playerside.P1;//先後を反転します。
                    KifuNode oldNode = genjo.Node_yomiNext;
                    genjo.Node_yomiNext = nextNode;
                    Sasiteseisei_FukasaYusen_Routine.WAAA_Yomu_Loop( genjo,owata);
                    genjo.Node_yomiNext = oldNode;//元に戻します。
                    genjo.YomuDeep--;//元に戻します。
                    genjo.Tesumi_yomiCur--;//元に戻します。
                    genjo.Pside_teban = genjo.Pside_teban == Playerside.P1 ? Playerside.P2 : Playerside.P1;//元に戻します。
                }
                else
                {
                    // もう深くよまないなら
                }

                wideCount++;
            }


            if (genjo.Args.YomuLimitter.Length <= genjo.YomuDeep + 1)//もう深く読まないなら
            {
                //
                // ログの書き出し
                //
                Util_GraphicalLog.Log(
                    true,//enableLog,
                    "指し手生成ログA",
                    "[" + Util_GraphicalLog.BoardFileLog_ToJsonStr(genjo.Args.LogF_moveKiki) + "]"
                );

                // 書き出した分はクリアーします。
                genjo.Args.LogF_moveKiki.boards.Clear();
            }
        }

    }

}
