﻿using Grayscale.P025_KifuLarabe.L007_Random;

namespace Grayscale.P043_Atama_Unou.L100_Unou
{

    /// <summary>
    /// 右脳です。
    /// 
    /// 三駒関係を入れるつもり☆
    /// </summary>
    public class Unou
    {

        /// <summary>
        /// ９×９の将棋盤のマス数☆
        /// </summary>
        private static int BAN_SIZE = 81;

        /// <summary>
        /// １２２４種類の調査項目☆
        ///                         （内訳
        ///                                 歩1～81・香1～81・桂1～81・銀1～81・金1～81・飛1～81・角1～81、  ※８１マス上の自分の駒
        ///                                 歩1～81・香1～81・桂1～81・銀1～81・金1～81・飛1～81・角1～81、　※８１マス上の相手の駒
        ///                                 歩0・歩1・歩2・歩3・歩4・歩5・歩6・歩7・歩8・歩9・
        ///                                 歩10・歩11・歩12・歩13・歩14・歩15・歩16・歩17・歩18・
        ///                                 香0・香1・香2・香3・香4・桂0・桂1・桂2・桂3・桂4・
        ///                                 銀0・銀1・銀2・銀3・銀4・金0・金1・金2・金3・金4・
        ///                                 飛0・飛1・飛2・角0・角1・角2、                                    ※自分の持ち駒
        ///                                 歩0・歩1・歩2・歩3・歩4・歩5・歩6・歩7・歩8・歩9・
        ///                                 歩10・歩11・歩12・歩13・歩14・歩15・歩16・歩17・歩18・
        ///                                 香0・香1・香2・香3・香4・桂0・桂1・桂2・桂3・桂4・
        ///                                 銀0・銀1・銀2・銀3・銀4・金0・金1・金2・金3・金4・
        ///                                 飛0・飛1・飛2・角0・角1・角2、                                    ※相手の持ち駒
        ///                         ）
        /// </summary>
        private static int CHOSA_KOMOKU = 1224;

        /// <summary>
        /// 三駒関係が入っている３次元配列☆
        /// 
        /// よく分かってないんだが　多分、
        /// 自玉の位置８１マス　×　相手玉の位置８１マス　×　１２２４種類の調査項目
        /// で、計8004420サイズの配列になると思う☆
        /// 
        /// </summary>
        public double[,,] SankomaKankei_KKP { get; set; }

        public Unou()
        {
            this.SankomaKankei_KKP = new double[BAN_SIZE, BAN_SIZE, CHOSA_KOMOKU];
        }

        /// <summary>
        /// 適当に数字を埋めます☆
        /// </summary>
        public void Make_Random()
        {
            for (int iJigyoku = 0; iJigyoku < BAN_SIZE; iJigyoku++)//自玉
            {
                for (int iAitegyoku = 0; iAitegyoku < BAN_SIZE; iAitegyoku++)//相手玉
                {
                    for (int iChosaKomoku = 0; iChosaKomoku < CHOSA_KOMOKU; iChosaKomoku++)//相手玉
                    {
                        // 0.0～1.0
                        this.SankomaKankei_KKP[iJigyoku,iAitegyoku,iChosaKomoku] = LarabeRandom.Random.NextDouble();
                    }
                }
            }
        }

    }
}
