﻿using Grayscale.P025_KifuLarabe.L00012_Atom;
using Grayscale.P025_KifuLarabe.L00025_Struct;
using Grayscale.P025_KifuLarabe.L00050_StructShogi;
using Grayscale.P025_KifuLarabe.L004_StructShogi;
using Grayscale.P025_KifuLarabe.L012_Common;
using Grayscale.P040_Kokoro.L00050_Kokoro;
using Grayscale.P043_Atama_Unou.CS0_Interface.L00050_Unou;
using Grayscale.P045_Atama.L00025_KyHandan;
using System.Text;
using Finger = ProjectDark.NamedInt.StrictNamedInt0; //スプライト番号

namespace Grayscale.P045_Atama.L050_KyHandan
{


    /// <summary>
    /// 評価計算
    /// 
    /// 三駒関係ＫＫＰ。
    /// </summary>
    public class KyHandan_SankomaKankeiKkp : KyHandanAbstract
    {

        public KyHandan_SankomaKankeiKkp()
            : base(TenonagareName.SankomaKankeiKkp)
        {
        }


        /// <summary>
        /// 0.0d ～100.0d の範囲で、評価値を返します。数字が大きい方がグッドです。
        /// </summary>
        /// <param name="input_node"></param>
        /// <param name="playerInfo"></param>
        /// <returns></returns>
        public override void Keisan(out KyHyokaItem kyokumenScore, KyHandanArgs args, KwErrorHandler owata)
        {
            double score = 0.0;
            SkyConst src_Sky = args.Node.Value.ToKyokumenConst;

            // 自玉の位置
            RO_Star_Koma koma_Jigyoku = Util_Koma.AsKoma(src_Sky.StarlightIndexOf(Util_Sky.Fingers_ByOkibaPsideSyuruiNow(src_Sky, Okiba.ShogiBan, args.PlayerInfo.Playerside, Ks14.H06_Oh, owata).ToFirst()).Now);

            if(Okiba.ShogiBan != Util_Masu.Masu_ToOkiba( koma_Jigyoku.Masu))
            {
                // 自玉が将棋盤上に無い場合
                goto gt_Next3;
            }
            int masuHandle_Jigyoku = Util_Masu.AsMasuNumber(koma_Jigyoku.Masu);

            // 相手玉の位置
            RO_Star_Koma koma_Aitegyoku = Util_Koma.AsKoma(src_Sky.StarlightIndexOf(Util_Sky.Fingers_ByOkibaPsideSyuruiNow(src_Sky, Okiba.ShogiBan, KifuNodeImpl.GetReverseTebanside( args.PlayerInfo.Playerside), Ks14.H06_Oh, owata).ToFirst()).Now);

            if(Okiba.ShogiBan != Util_Masu.Masu_ToOkiba( koma_Aitegyoku.Masu))
            {
                // 相手玉が将棋盤上に無い場合
                goto gt_Next3;
            }
            int masuHandle_Aitegyoku = Util_Masu.AsMasuNumber(koma_Aitegyoku.Masu);


            // とりあえず、３８駒の位置だけ評価します。
            foreach (Finger figKoma in Finger_Honshogi.Items_KomaOnly)// 全駒
            {
                double subScore = 0.0;

                RO_Star_Koma koma = Util_Koma.AsKoma(src_Sky.StarlightIndexOf(figKoma).Now);

                if (Okiba.ShogiBan != Util_Masu.Masu_ToOkiba(koma.Masu))
                {
                    goto gt_Next2;
                }

                // １２２０種類の調査項目☆
                //                         （内訳
                //                                 歩1～81・香1～81・桂1～81・銀1～81・金1～81・飛1～81・角1～81、  ※８１マス上の自分の駒
                //                                 歩1～81・香1～81・桂1～81・銀1～81・金1～81・飛1～81・角1～81、　※８１マス上の相手の駒
                //                                 歩0・歩1・歩2・歩3・歩4・歩5・歩6・歩7・歩8・歩9・
                //                                 歩10・歩11・歩12・歩13・歩14・歩15・歩16・歩17・歩18・
                //                                 香0・香1・香2・香3・香4・桂0・桂1・桂2・桂3・桂4・
                //                                 銀0・銀1・銀2・銀3・銀4・金0・金1・金2・金3・金4・
                //                                 飛0・飛1・飛2・角0・角1・角2、                                    ※自分の持ち駒
                //                                 歩0・歩1・歩2・歩3・歩4・歩5・歩6・歩7・歩8・歩9・
                //                                 歩10・歩11・歩12・歩13・歩14・歩15・歩16・歩17・歩18・
                //                                 香0・香1・香2・香3・香4・桂0・桂1・桂2・桂3・桂4・
                //                                 銀0・銀1・銀2・銀3・銀4・金0・金1・金2・金3・金4・
                //                                 飛0・飛1・飛2・角0・角1・角2、                                    ※相手の持ち駒
                //                         ）

                // 駒Ｐのマス番号
                int masuHandle_P = Util_Masu.AsMasuNumber(koma.Masu);

                if (koma.Pside == args.PlayerInfo.Playerside)
                {
                    // 自分の駒

                    switch ( koma.ToNarazuCase())
                    {
                        case Ks14.H01_Fu:   subScore = args.Unou.SankomaKankei_KKP[masuHandle_Jigyoku, masuHandle_Aitegyoku, (int)SankomaKankeiKkp_ChosaKomoku.JiFu1 + masuHandle_P];   break;
                        case Ks14.H02_Kyo:  subScore = args.Unou.SankomaKankei_KKP[masuHandle_Jigyoku, masuHandle_Aitegyoku, (int)SankomaKankeiKkp_ChosaKomoku.JiKyo1 + masuHandle_P]; break;
                        case Ks14.H03_Kei:  subScore = args.Unou.SankomaKankei_KKP[masuHandle_Jigyoku, masuHandle_Aitegyoku, (int)SankomaKankeiKkp_ChosaKomoku.JiKei1 + masuHandle_P]; break;
                        case Ks14.H04_Gin:  subScore = args.Unou.SankomaKankei_KKP[masuHandle_Jigyoku, masuHandle_Aitegyoku, (int)SankomaKankeiKkp_ChosaKomoku.JiGin1 + masuHandle_P]; break;
                        case Ks14.H05_Kin:  subScore = args.Unou.SankomaKankei_KKP[masuHandle_Jigyoku, masuHandle_Aitegyoku, (int)SankomaKankeiKkp_ChosaKomoku.JiKin1 + masuHandle_P]; break;
                        case Ks14.H07_Hisya:subScore = args.Unou.SankomaKankei_KKP[masuHandle_Jigyoku, masuHandle_Aitegyoku, (int)SankomaKankeiKkp_ChosaKomoku.JiHi1 + masuHandle_P]; break;
                        case Ks14.H08_Kaku: subScore = args.Unou.SankomaKankei_KKP[masuHandle_Jigyoku, masuHandle_Aitegyoku, (int)SankomaKankeiKkp_ChosaKomoku.JiKaku1 + masuHandle_P]; break;
                    }

                }
                else
                {
                    // 相手の駒

                    switch (koma.ToNarazuCase())
                    {
                        case Ks14.H01_Fu: subScore = args.Unou.SankomaKankei_KKP[masuHandle_Jigyoku, masuHandle_Aitegyoku, (int)SankomaKankeiKkp_ChosaKomoku.AiteFu1 + masuHandle_P]; break;
                        case Ks14.H02_Kyo: subScore = args.Unou.SankomaKankei_KKP[masuHandle_Jigyoku, masuHandle_Aitegyoku, (int)SankomaKankeiKkp_ChosaKomoku.AiteKyo1 + masuHandle_P]; break;
                        case Ks14.H03_Kei: subScore = args.Unou.SankomaKankei_KKP[masuHandle_Jigyoku, masuHandle_Aitegyoku, (int)SankomaKankeiKkp_ChosaKomoku.AiteKei1 + masuHandle_P]; break;
                        case Ks14.H04_Gin: subScore = args.Unou.SankomaKankei_KKP[masuHandle_Jigyoku, masuHandle_Aitegyoku, (int)SankomaKankeiKkp_ChosaKomoku.AiteGin1 + masuHandle_P]; break;
                        case Ks14.H05_Kin: subScore = args.Unou.SankomaKankei_KKP[masuHandle_Jigyoku, masuHandle_Aitegyoku, (int)SankomaKankeiKkp_ChosaKomoku.AiteKin1 + masuHandle_P]; break;
                        case Ks14.H07_Hisya: subScore = args.Unou.SankomaKankei_KKP[masuHandle_Jigyoku, masuHandle_Aitegyoku, (int)SankomaKankeiKkp_ChosaKomoku.AiteHi1 + masuHandle_P]; break;
                        case Ks14.H08_Kaku: subScore = args.Unou.SankomaKankei_KKP[masuHandle_Jigyoku, masuHandle_Aitegyoku, (int)SankomaKankeiKkp_ChosaKomoku.AiteKaku1 + masuHandle_P]; break;
                    }
                }

                score += subScore;

            gt_Next2:
                ;
            }


            gt_Next3:
            
            string meisai = "";
#if DEBUG
            // 明細
            {
                StringBuilder sb = new StringBuilder();
                sb.Append(" " + score);
                sb.Append("点    ");
                sb.Append(" 三駒関係ＫＫＰ");
                meisai = sb.ToString();
            }
#endif

            kyokumenScore = new KyHyoka100limitItemImpl(args.TenonagareGenjo.ScoreKeisu, score, meisai);
        }


    }
}
